package tools.wztosql;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Iterator;
import provider.MapleData;
import provider.MapleDataProvider;
import provider.MapleDataProviderFactory;

public class WzStringDumper {

   public static void main(String[] args) throws FileNotFoundException, IOException {
      MapleDataProvider stringProvider = MapleDataProviderFactory.getDataProvider("string.wz");
      MapleData cash = stringProvider.getData("Cash.img");
      MapleData consume = stringProvider.getData("Consume.img");
      MapleData eqp = stringProvider.getData("Eqp.img").getChildByPath("Eqp");
      MapleData etc = stringProvider.getData("Etc.img").getChildByPath("Etc");
      MapleData ins = stringProvider.getData("Ins.img");
      MapleData pet = stringProvider.getData("Pet.img");
      MapleData map = stringProvider.getData("Map.img");
      MapleData mob = stringProvider.getData("Mob.img");
      MapleData skill = stringProvider.getData("Skill.img");
      MapleData npc = stringProvider.getData("Npc.img");
      String output = args[0];
      File outputDir = new File(output);
      File cashTxt = new File(output + "\\Cash.txt");
      File useTxt = new File(output + "\\Use.txt");
      File eqpDir = new File(output + "\\Equip");
      File etcTxt = new File(output + "\\Etc.txt");
      File insTxt = new File(output + "\\Setup.txt");
      File petTxt = new File(output + "\\Pet.txt");
      File mapTxt = new File(output + "\\Map.txt");
      File mobTxt = new File(output + "\\Mob.txt");
      File skillTxt = new File(output + "\\Skill.txt");
      File npcTxt = new File(output + "\\NPC.txt");
      outputDir.mkdir();
      cashTxt.createNewFile();
      useTxt.createNewFile();
      eqpDir.mkdir();
      etcTxt.createNewFile();
      insTxt.createNewFile();
      petTxt.createNewFile();
      mapTxt.createNewFile();
      mobTxt.createNewFile();
      skillTxt.createNewFile();
      npcTxt.createNewFile();
      System.out.println("提取 Cash.img 數據...");
      PrintWriter writer = new PrintWriter(new FileOutputStream(cashTxt));

      Iterator var25;
      MapleData child;
      MapleData nameData;
      MapleData name;
      String bookData;
      String name1;
      for(var25 = cash.getChildren().iterator(); var25.hasNext(); writer.println(child.getName() + " - " + bookData + " - " + name1)) {
         child = (MapleData)var25.next();
         nameData = child.getChildByPath("name");
         name = child.getChildByPath("desc");
         bookData = "";
         name1 = "(无描述)";
         if(nameData != null) {
            bookData = (String)nameData.getData();
         }

         if(name != null) {
            name1 = (String)name.getData();
         }
      }

      writer.flush();
      writer.close();
      System.out.println("Cash.img 提取完成.");
      System.out.println("提取 Consume.img 數據...");
      writer = new PrintWriter(new FileOutputStream(useTxt));

      for(var25 = consume.getChildren().iterator(); var25.hasNext(); writer.println(child.getName() + " - " + bookData + " - " + name1)) {
         child = (MapleData)var25.next();
         nameData = child.getChildByPath("name");
         name = child.getChildByPath("desc");
         bookData = "";
         name1 = "(无描述)";
         if(nameData != null) {
            bookData = (String)nameData.getData();
         }

         if(name != null) {
            name1 = (String)name.getData();
         }
      }

      writer.flush();
      writer.close();
      System.out.println("Consume.img 提取完成.");
      System.out.println("提取 Eqp.img 數據...");
      var25 = eqp.getChildren().iterator();

      MapleData name5;
      while(var25.hasNext()) {
         child = (MapleData)var25.next();
         System.out.println("提取 " + child.getName() + " 數據...");
         File nameData1 = new File(output + "\\Equip\\" + child.getName() + ".txt");
         nameData1.createNewFile();
         PrintWriter name3 = new PrintWriter(new FileOutputStream(nameData1));

         String name2;
         String desc1;
         for(Iterator bookData1 = child.getChildren().iterator(); bookData1.hasNext(); name3.println(name5.getName() + " - " + name2 + " - " + desc1)) {
            name5 = (MapleData)bookData1.next();
            MapleData desc = name5.getChildByPath("name");
            MapleData mapName = name5.getChildByPath("desc");
            name2 = "";
            desc1 = "(无描述)";
            if(desc != null) {
               name2 = (String)desc.getData();
            }

            if(mapName != null) {
               desc1 = (String)mapName.getData();
            }
         }

         name3.flush();
         name3.close();
         System.out.println(child.getName() + " 提取完成.");
      }

      System.out.println("Eqp.img 提取完成.");
      System.out.println("提取 Etc.img 數據...");
      writer = new PrintWriter(new FileOutputStream(etcTxt));

      for(var25 = etc.getChildren().iterator(); var25.hasNext(); writer.println(child.getName() + " - " + bookData + " - " + name1)) {
         child = (MapleData)var25.next();
         nameData = child.getChildByPath("name");
         name = child.getChildByPath("desc");
         bookData = "";
         name1 = "(无描述)";
         if(nameData != null) {
            bookData = (String)nameData.getData();
         }

         if(name != null) {
            name1 = (String)name.getData();
         }
      }

      writer.flush();
      writer.close();
      System.out.println("Etc.img 提取完成.");
      System.out.println("提取 Ins.img 數據...");
      writer = new PrintWriter(new FileOutputStream(insTxt));

      for(var25 = ins.getChildren().iterator(); var25.hasNext(); writer.println(child.getName() + " - " + bookData + " - " + name1)) {
         child = (MapleData)var25.next();
         nameData = child.getChildByPath("name");
         name = child.getChildByPath("desc");
         bookData = "";
         name1 = "(无描述)";
         if(nameData != null) {
            bookData = (String)nameData.getData();
         }

         if(name != null) {
            name1 = (String)name.getData();
         }
      }

      writer.flush();
      writer.close();
      System.out.println("Ins.img 提取完成.");
      System.out.println("提取 Pet.img 數據...");
      writer = new PrintWriter(new FileOutputStream(petTxt));

      for(var25 = pet.getChildren().iterator(); var25.hasNext(); writer.println(child.getName() + " - " + bookData + " - " + name1)) {
         child = (MapleData)var25.next();
         nameData = child.getChildByPath("name");
         name = child.getChildByPath("desc");
         bookData = "";
         name1 = "(无描述)";
         if(nameData != null) {
            bookData = (String)nameData.getData();
         }

         if(name != null) {
            name1 = (String)name.getData();
         }
      }

      writer.flush();
      writer.close();
      System.out.println("Pet.img 提取完成.");
      System.out.println("提取 Map.img 數據...");
      writer = new PrintWriter(new FileOutputStream(mapTxt));
      var25 = map.getChildren().iterator();

      String desc2;
      MapleData bookData2;
      while(var25.hasNext()) {
         child = (MapleData)var25.next();
         writer.println(child.getName());
         writer.println();

         String mapName1;
         for(Iterator nameData2 = child.getChildren().iterator(); nameData2.hasNext(); writer.println(name.getName() + " - " + desc2 + " - " + mapName1)) {
            name = (MapleData)nameData2.next();
            bookData2 = name.getChildByPath("streetName");
            name5 = name.getChildByPath("mapName");
            desc2 = "(无數據名)";
            mapName1 = "(无地圖名)";
            if(bookData2 != null) {
               desc2 = (String)bookData2.getData();
            }

            if(name5 != null) {
               mapName1 = (String)name5.getData();
            }
         }

         writer.println();
      }

      writer.flush();
      writer.close();
      System.out.println("Map.img 提取完成.");
      System.out.println("提取 Mob.img 數據...");
      writer = new PrintWriter(new FileOutputStream(mobTxt));

      String name4;
      for(var25 = mob.getChildren().iterator(); var25.hasNext(); writer.println(child.getName() + " - " + name4)) {
         child = (MapleData)var25.next();
         nameData = child.getChildByPath("name");
         name4 = "";
         if(nameData != null) {
            name4 = (String)nameData.getData();
         }
      }

      writer.flush();
      writer.close();
      System.out.println("Mob.img 提取完成.");
      System.out.println("提取 Skill.img 數據...");
      writer = new PrintWriter(new FileOutputStream(skillTxt));
      var25 = skill.getChildren().iterator();

      while(var25.hasNext()) {
         child = (MapleData)var25.next();
         nameData = child.getChildByPath("name");
         name = child.getChildByPath("desc");
         bookData2 = child.getChildByPath("bookName");
         name1 = "";
         desc2 = "";
         if(nameData != null) {
            name1 = (String)nameData.getData();
         }

         if(name != null) {
            desc2 = (String)name.getData();
         }

         if(bookData2 == null) {
            writer.println(child.getName() + " - " + name1 + " - " + desc2);
         }
      }

      writer.flush();
      writer.close();
      System.out.println("Skill.img 提取完成.");
      System.out.println("提取 Npc.img 數據...");
      writer = new PrintWriter(new FileOutputStream(npcTxt));

      for(var25 = npc.getChildren().iterator(); var25.hasNext(); writer.println(child.getName() + " - " + name4)) {
         child = (MapleData)var25.next();
         nameData = child.getChildByPath("name");
         name4 = "";
         if(nameData != null) {
            name4 = (String)nameData.getData();
         }
      }

      writer.flush();
      writer.close();
      System.out.println("Npc.img 提取完成.");
   }
}
